//+------------------------------------------------------------------+
//|                                               TradeMasterExp.mq4 |
//|                          Copyright  2006, HomeSoft-Tartan Corp. |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, HomeSoft-Tartan Corp."
#property link      "spiky@sinet.spb.ru"

extern double Lots = 0.1;

int lockord=6,lock=1,tpr=50,udel=5,zap=10,stl=150;

double mlot = 0.0;
double topup=0.0,topdn=0.0;

int j = 0, pr = 1;

bool ft = true;

int blok = 0;
int s = 0, os = 0;
int b = 0, ob = 0;

double ssum, bsum, summ;

int top = 0, cnt = 0;
int del = 0, spl = 0, lblok = 0;

string dw = " ";

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   j=j+1; 
   mlot = Lots;
   
 
   if((Minute()==0) && (Seconds()<=15))
   {
      j=0;
   }

   if((Hour()==0 && Minute()<5) || (ft==true))
   {
      if(Hour()==0 && Minute()<5) pr=1;
      if(Hour()>0) pr=MathRound((Hour()*60+Minute())/Period())+1;
      if (Hour()==0 && Minute()!=0) pr=MathRound(Minute()/Period())+1;
      top=Close[pr];
      topup=Close[pr]+30*Point;
      topdn=Close[pr]-30*Point;
      
      MoveHLine("Mid",Time[10],top,Time[0],top,Gold,1,STYLE_DOT);
      MoveHLine("LUP",Time[10],topup,Time[0],topup,Lime,1,STYLE_DOT);
      MoveHLine("LDN",Time[10],topdn,Time[0],topdn,Magenta,1,STYLE_DOT);
   }
     
   os=0; ob=0; s=0; b=0; summ=0; bsum=0; ssum=0;
   for(cnt=0;cnt<=OrdersTotal(); cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS);
      if(OrderType()==OP_SELL && OrderSymbol()==Symbol())
      {
         ssum = ssum + OrderProfit();
         s=s+1;
      }
      if(OrderType()==OP_BUY && OrderSymbol()==Symbol())
      {
         bsum = bsum + OrderProfit();
         b=b+1;
      }
      if(OrderType()==OP_SELLSTOP && OrderSymbol()==Symbol())
      {
         os=os+1;
      }
      if(OrderType()==OP_BUYSTOP && OrderSymbol()==Symbol())
      {
         ob=ob+1;
      }
   }

   summ = MathRound(ssum+bsum);
   
   
   if((s+b)==0) spl=0;
   if((s+b+os+ob)==0)
   {
      lblok=0; blok=0;
   }

   if((os+ob)>0 && Hour()==23 && Minute()>55 && (s+b)==0)
   {
      for(cnt=0; cnt<=OrdersTotal(); cnt++)
      {
         OrderSelect(cnt, SELECT_BY_POS);
         if(OrderSymbol()==Symbol() && OrderType()==OP_BUYSTOP)
         {
            OrderDelete(OrderTicket());
         }
         if(OrderSymbol()==Symbol() && OrderType()==OP_SELLSTOP)
         {
            OrderDelete(OrderTicket());
         }
      }
   }

   if(summ>=300 && (s+b)>=2) spl=1;
   
   if(spl==1)
   {
      for(cnt=0; cnt<=OrdersTotal(); cnt++)
      {
         if(OrderType()==OP_SELL && OrderSymbol()==Symbol())
         {
            OrderClose(OrderTicket(),OrderLots(),Ask,5,Red);
         }
         if(OrderType()==OP_BUY && OrderSymbol()==Symbol())
         {
            OrderClose(OrderTicket(),OrderLots(),Bid,5,Red);
         }
      }
   }

   if(DayOfWeek()==2) dw="";
   if(DayOfWeek()==3) dw="";
   if(DayOfWeek()==4) dw="";
   if(DayOfWeek()==5) dw="";
   if(DayOfWeek()==6) dw="";

   if(Close[0]>topup) del=MathRound((Close[0]-topup)/Point);
   if(Close[0]<topdn) del=MathRound((topdn-Close[0])/Point);
   if(Close[0]<=topup && Close[0]>=topdn) del=0;

   Comment("Data: ",Year(),".",Month(),".",Day(),"  Day=",dw,"  Time ",Hour(),":",Minute(),"   Tiks=",j,"\n", 
    "Delta=",del,"  Blok=",blok,"  Min=",topdn,"  Max=",topup,"  Price=",Close[0],"  Profit=",summ); 

   if(lock==1 && blok==1 && Hour()>0 && Hour()<23 && summ<-300 && lblok==0)
   {
      if((s-b)==1 && ssum<-800)
      {
         OrderSend(Symbol(),OP_BUY,2*mlot,Ask,3,Ask-2*stl*Point,Ask+2*tpr*Point);
         lblok=1;
      }
      if((b-s)==1 && bsum<-800)
      {
         OrderSend(Symbol(),OP_SELL,2*mlot,Bid,3,Bid+2*stl*Point,Bid-2*tpr*Point);
         lblok=1;
      }
   }

   if(((Hour()==0 && Minute()>5) || (Hour()>0 && Hour()<23)) && blok==0)
   {
      if(DayOfWeek()==6 && Hour()>=21) return(0);
      if(del>udel && Close[0]>topup)
      {
         OrderSend(Symbol(),OP_SELLSTOP,mlot,topup,3,topup+stl*Point,topup-tpr*Point);
         blok=1;
         
      }
      if(del>udel && Close[0]<topdn)
      {
         OrderSend(Symbol(),OP_BUYSTOP,mlot,topdn,3,topdn-stl*Point,topdn+tpr*Point);
         blok=1;
      }
   }

   return(0);
}
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                           |
//+------------------------------------------------------------------+
void MoveHLine(string name, datetime time, double price, datetime time1, double price1, 
                  int objcolor, int width, int style)
{
   if(ObjectFind(name)==-1)
   {
      ObjectCreate(name,OBJ_HLINE,0,time,price);
      ObjectSet(name, OBJPROP_COLOR, objcolor);
      ObjectSet(name, OBJPROP_WIDTH, width);
      ObjectSet(name, OBJPROP_STYLE, style);
   } else {
      ObjectMove(name, 1, time1, price1);
   }
}


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }